<template src="./createInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import AutocompleteComponent from '../../../../../inputs/AutocompleteComponent.vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('autocomplete-component', AutocompleteComponent);
    Vue.component('select-component', SelectComponent);

    export default {

        data() {

            return {

                user: null,

                existingUser: false,

                autocompleteKey: 0,

                orderStatuses: [
                    {
                        value: 0,
                        label: 'Pending'
                    },
                    {
                        value: 1,
                        label: 'Accepted'
                    },
                    {
                        value: 2,
                        label: 'Declined'
                    }
                ],

                deliveryCompanies: [
                    {
                        value: 'Post Express',
                        label: 'Post Express'
                    },
                    {
                        value: 'Daily Express',
                        label: 'Daily Express'
                    }
                ],

                billingInfo: {
                    user_id: null,
                    status: 1,
                    admin_comment: '',
                    user_comment: '',
                    billing_name: '',
                    billing_email: '',
                    billing_phone_number: '',
                    billing_address: '',
                    billing_city: '',
                    billing_state: '',
                    billing_zip: '',
                    billing_floor: '',
                    billing_flat: '',
                    billing_intercom: '',
                    delivery_company: ''
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Set user on autocomplete select.
             *
             * @param user
             */
            setUser(user) {

                this.user                               = user;
                this.billingInfo.user_id                = user.id;
                this.billingInfo.billing_name           = user.name;
                this.billingInfo.billing_email          = user.email;
                this.billingInfo.billing_phone_number   = user.phone_number;
            }
        },

        watch: {

            /**
             * Reset auto
             *
             * @param newExistingUser
             */
            existingUser(newExistingUser) {

                if (newExistingUser === false) {

                    this.user                               = null;
                    this.billingInfo.user_id                = null;
                    this.billingInfo.billing_name           = '';
                    this.billingInfo.billing_email          = '';
                    this.billingInfo.billing_phone_number   = '';

                    this.autocompleteKey++;
                }
            },


            /**
             * Set order billing info store object
             *
             * @param newBillingInfo
             */
            billingInfo: {

                handler(newBillingInfo) {

                    this.$store.dispatch('setOrderBillingInfo', newBillingInfo);
                },

                deep: true
            },


            /**
             * This event is watched in CreateProductsComponent.
             */
            'billingInfo.status'() {

                eventBus.$emit('order-status-changed', this.billingInfo.status);
            }
        }
    }

</script>